Makefile 8.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262
  1. # set the shell to bash always
  2. SHELL := /bin/bash
  3. # set make and shell flags to exit on errors
  4. MAKEFLAGS += --warn-undefined-variables
  5. .SHELLFLAGS := -euo pipefail -c
  6. ARCH ?= amd64 arm64
  7. BUILD_ARGS ?= CGO_ENABLED=0
  8. DOCKER_BUILD_ARGS ?=
  9. DOCKERFILE ?= Dockerfile
  10. # default target is build
  11. .DEFAULT_GOAL := all
  12. .PHONY: all
  13. all: $(addprefix build-,$(ARCH))
  14. # Image registry for build/push image targets
  15. export IMAGE_REGISTRY ?= ghcr.io
  16. export IMAGE_REPO ?= external-secrets/external-secrets
  17. export IMAGE_NAME ?= $(IMAGE_REGISTRY)/$(IMAGE_REPO)
  18. BUNDLE_DIR ?= deploy/crds
  19. CRD_DIR ?= config/crds
  20. HELM_DIR ?= deploy/charts/external-secrets
  21. TF_DIR ?= terraform
  22. OUTPUT_DIR ?= bin
  23. # Get the currently used golang install path (in GOPATH/bin, unless GOBIN is set)
  24. ifeq (,$(shell go env GOBIN))
  25. GOBIN=$(shell go env GOPATH)/bin
  26. else
  27. GOBIN=$(shell go env GOBIN)
  28. endif
  29. # check if there are any existing `git tag` values
  30. ifeq ($(shell git tag),)
  31. # no tags found - default to initial tag `v0.0.0`
  32. export VERSION := $(shell echo "v0.0.0-$$(git rev-list HEAD --count)-g$$(git describe --dirty --always)" | sed 's/-/./2' | sed 's/-/./2')
  33. else
  34. # use tags
  35. export VERSION := $(shell git describe --dirty --always --tags --exclude 'helm*' | sed 's/-/./2' | sed 's/-/./2')
  36. endif
  37. TAG_SUFFIX ?=
  38. export IMAGE_TAG ?= $(VERSION)$(TAG_SUFFIX)
  39. # ====================================================================================
  40. # Colors
  41. BLUE := $(shell printf "\033[34m")
  42. YELLOW := $(shell printf "\033[33m")
  43. RED := $(shell printf "\033[31m")
  44. GREEN := $(shell printf "\033[32m")
  45. CNone := $(shell printf "\033[0m")
  46. # ====================================================================================
  47. # Logger
  48. TIME_LONG = `date +%Y-%m-%d' '%H:%M:%S`
  49. TIME_SHORT = `date +%H:%M:%S`
  50. TIME = $(TIME_SHORT)
  51. INFO = echo ${TIME} ${BLUE}[ .. ]${CNone}
  52. WARN = echo ${TIME} ${YELLOW}[WARN]${CNone}
  53. ERR = echo ${TIME} ${RED}[FAIL]${CNone}
  54. OK = echo ${TIME} ${GREEN}[ OK ]${CNone}
  55. FAIL = (echo ${TIME} ${RED}[FAIL]${CNone} && false)
  56. # ====================================================================================
  57. # Conformance
  58. reviewable: generate docs manifests helm.generate helm.docs lint ## Ensure a PR is ready for review.
  59. @go mod tidy
  60. @cd e2e/ && go mod tidy
  61. check-diff: reviewable ## Ensure branch is clean.
  62. @$(INFO) checking that branch is clean
  63. @test -z "$$(git status --porcelain)" || (echo "$$(git status --porcelain)" && $(FAIL))
  64. @$(OK) branch is clean
  65. # ====================================================================================
  66. # Golang
  67. .PHONY: test
  68. test: generate ## Run tests
  69. @$(INFO) go test unit-tests
  70. go test -race -v $(shell go list ./... | grep -v e2e) -coverprofile cover.out
  71. @$(OK) go test unit-tests
  72. .PHONY: test.e2e
  73. test.e2e: generate ## Run e2e tests
  74. @$(INFO) go test e2e-tests
  75. $(MAKE) -C ./e2e test
  76. @$(OK) go test e2e-tests
  77. .PHONY: test.e2e.managed
  78. test.e2e.managed: generate ## Run e2e tests managed
  79. @$(INFO) go test e2e-tests-managed
  80. $(MAKE) -C ./e2e test.managed
  81. @$(OK) go test e2e-tests-managed
  82. .PHONY: build
  83. build: $(addprefix build-,$(ARCH)) ## Build binary
  84. .PHONY: build-%
  85. build-%: generate ## Build binary for the specified arch
  86. @$(INFO) go build $*
  87. $(BUILD_ARGS) GOOS=linux GOARCH=$* \
  88. go build -o '$(OUTPUT_DIR)/external-secrets-linux-$*' main.go
  89. @$(OK) go build $*
  90. lint.check: ## Check install of golanci-lint
  91. @if ! golangci-lint --version > /dev/null 2>&1; then \
  92. echo -e "\033[0;33mgolangci-lint is not installed: run \`\033[0;32mmake lint.install\033[0m\033[0;33m\` or install it from https://golangci-lint.run\033[0m"; \
  93. exit 1; \
  94. fi
  95. lint.install: ## Install golangci-lint to the go bin dir
  96. @if ! golangci-lint --version > /dev/null 2>&1; then \
  97. echo "Installing golangci-lint"; \
  98. curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(GOBIN) v1.49.0; \
  99. fi
  100. lint: lint.check ## Run golangci-lint
  101. @if ! golangci-lint run; then \
  102. echo -e "\033[0;33mgolangci-lint failed: some checks can be fixed with \`\033[0;32mmake fmt\033[0m\033[0;33m\`\033[0m"; \
  103. exit 1; \
  104. fi
  105. @$(OK) Finished linting
  106. fmt: lint.check ## Ensure consistent code style
  107. @go mod tidy
  108. @cd e2e/ && go mod tidy
  109. @go fmt ./...
  110. @golangci-lint run --fix > /dev/null 2>&1 || true
  111. @$(OK) Ensured consistent code style
  112. generate: ## Generate code and crds
  113. @./hack/crd.generate.sh $(BUNDLE_DIR) $(CRD_DIR)
  114. @$(OK) Finished generating deepcopy and crds
  115. # ====================================================================================
  116. # Local Utility
  117. # This is for running out-of-cluster locally, and is for convenience.
  118. # For more control, try running the binary directly with different arguments.
  119. run: generate ## Run app locally (without a k8s cluster)
  120. go run ./main.go
  121. manifests: helm.generate ## Generate manifests from helm chart
  122. mkdir -p $(OUTPUT_DIR)/deploy/manifests
  123. helm template external-secrets $(HELM_DIR) -f deploy/manifests/helm-values.yaml > $(OUTPUT_DIR)/deploy/manifests/external-secrets.yaml
  124. crds.install: generate ## Install CRDs into a cluster. This is for convenience
  125. kubectl apply -f $(BUNDLE_DIR)
  126. crds.uninstall: ## Uninstall CRDs from a cluster. This is for convenience
  127. kubectl delete -f $(BUNDLE_DIR)
  128. # ====================================================================================
  129. # Helm Chart
  130. helm.docs: ## Generate helm docs
  131. @cd $(HELM_DIR); \
  132. docker run --rm -v $(shell pwd)/$(HELM_DIR):/helm-docs -u $(shell id -u) jnorwood/helm-docs:v1.5.0
  133. HELM_VERSION ?= $(shell helm show chart $(HELM_DIR) | grep 'version:' | sed 's/version: //g')
  134. helm.build: helm.generate ## Build helm chart
  135. @$(INFO) helm package
  136. @helm package $(HELM_DIR) --dependency-update --destination $(OUTPUT_DIR)/chart
  137. @mv $(OUTPUT_DIR)/chart/external-secrets-$(HELM_VERSION).tgz $(OUTPUT_DIR)/chart/external-secrets.tgz
  138. @$(OK) helm package
  139. helm.generate:
  140. ./hack/helm.generate.sh $(BUNDLE_DIR) $(HELM_DIR)
  141. @$(OK) Finished generating helm chart files
  142. # ====================================================================================
  143. # Documentation
  144. .PHONY: docs
  145. docs: generate ## Generate docs
  146. $(MAKE) -C ./hack/api-docs build
  147. .PHONY: docs.publish
  148. docs.publish: generate ## Generate and deploys docs
  149. $(MAKE) -C ./hack/api-docs build.publish
  150. .PHONY: docs.serve
  151. docs.serve: ## Serve docs
  152. $(MAKE) -C ./hack/api-docs serve
  153. # ====================================================================================
  154. # Build Artifacts
  155. build.all: docker.build helm.build ## Build all artifacts (docker image, helm chart)
  156. docker.image:
  157. @echo $(IMAGE_NAME):$(IMAGE_TAG)
  158. docker.tag:
  159. @echo $(IMAGE_TAG)
  160. docker.build: $(addprefix build-,$(ARCH)) ## Build the docker image
  161. @$(INFO) docker build
  162. @docker build -f $(DOCKERFILE) . $(DOCKER_BUILD_ARGS) -t $(IMAGE_NAME):$(IMAGE_TAG)
  163. @$(OK) docker build
  164. docker.push: ## Push the docker image to the registry
  165. @$(INFO) docker push
  166. @docker push $(IMAGE_NAME):$(IMAGE_TAG)
  167. @$(OK) docker push
  168. # RELEASE_TAG is tag to promote. Default is promoting to main branch, but can be overriden
  169. # to promote a tag to a specific version.
  170. RELEASE_TAG ?= $(IMAGE_TAG)
  171. SOURCE_TAG ?= $(VERSION)$(TAG_SUFFIX)
  172. docker.promote: ## Promote the docker image to the registry
  173. @$(INFO) promoting $(SOURCE_TAG) to $(RELEASE_TAG)
  174. docker manifest inspect --verbose $(IMAGE_NAME):$(SOURCE_TAG) > .tagmanifest
  175. for digest in $$(jq -r 'if type=="array" then .[].Descriptor.digest else .Descriptor.digest end' < .tagmanifest); do \
  176. docker pull $(IMAGE_NAME)@$$digest; \
  177. done
  178. docker manifest create $(IMAGE_NAME):$(RELEASE_TAG) \
  179. $$(jq -j '"--amend $(IMAGE_NAME)@" + if type=="array" then .[].Descriptor.digest else .Descriptor.digest end + " "' < .tagmanifest)
  180. docker manifest push $(IMAGE_NAME):$(RELEASE_TAG)
  181. @$(OK) docker push $(RELEASE_TAG) \
  182. # ====================================================================================
  183. # Terraform
  184. tf.plan.%: ## Runs terrform plan for a provider
  185. @cd $(TF_DIR)/$*; \
  186. terraform init; \
  187. terraform plan
  188. tf.apply.%: ## Runs terrform apply for a provider
  189. @cd $(TF_DIR)/$*; \
  190. terraform init; \
  191. terraform apply -auto-approve
  192. tf.destroy.%: ## Runs terrform destroy for a provider
  193. @cd $(TF_DIR)/$*; \
  194. terraform init; \
  195. terraform destroy -auto-approve
  196. tf.show.%: ## Runs terrform show for a provider and outputs to a file
  197. @cd $(TF_DIR)/$*; \
  198. terraform init; \
  199. terraform plan -out tfplan.binary; \
  200. terraform show -json tfplan.binary > plan.json
  201. # ====================================================================================
  202. # Help
  203. # only comments after make target name are shown as help text
  204. help: ## Displays this help message
  205. @echo -e "$$(grep -hE '^\S+:.*##' $(MAKEFILE_LIST) | sed -e 's/:.*##\s*/:/' -e 's/^\(.\+\):\(.*\)/\\x1b[36m\1\\x1b[m:\2/' | column -c2 -t -s : | sort)"